/* BackendInterface.c generated by valac 0.56.3, the Vala compiler
 * generated from BackendInterface.vala, do not modify */

/*-
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <appstream.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	BACKEND_TYPE_PACKAGEKIT,
	BACKEND_TYPE_UBUNTU_DRIVERS
} BackendType;

#define TYPE_BACKEND_TYPE (backend_type_get_type ())

#define APP_CENTER_CORE_TYPE_BACKEND (app_center_core_backend_get_type ())
#define APP_CENTER_CORE_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_BACKEND, AppCenterCoreBackend))
#define APP_CENTER_CORE_IS_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_BACKEND))
#define APP_CENTER_CORE_BACKEND_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), APP_CENTER_CORE_TYPE_BACKEND, AppCenterCoreBackendIface))

typedef struct _AppCenterCoreBackend AppCenterCoreBackend;
typedef struct _AppCenterCoreBackendIface AppCenterCoreBackendIface;

#define APP_CENTER_CORE_TYPE_PACKAGE (app_center_core_package_get_type ())
#define APP_CENTER_CORE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackage))
#define APP_CENTER_CORE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))
#define APP_CENTER_CORE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_PACKAGE))
#define APP_CENTER_CORE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_PACKAGE, AppCenterCorePackageClass))

typedef struct _AppCenterCorePackage AppCenterCorePackage;
typedef struct _AppCenterCorePackageClass AppCenterCorePackageClass;

#define APP_CENTER_CORE_TYPE_PACKAGE_DETAILS (app_center_core_package_details_get_type ())
#define APP_CENTER_CORE_PACKAGE_DETAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, AppCenterCorePackageDetails))
#define APP_CENTER_CORE_PACKAGE_DETAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, AppCenterCorePackageDetailsClass))
#define APP_CENTER_CORE_IS_PACKAGE_DETAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS))
#define APP_CENTER_CORE_IS_PACKAGE_DETAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS))
#define APP_CENTER_CORE_PACKAGE_DETAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_PACKAGE_DETAILS, AppCenterCorePackageDetailsClass))

typedef struct _AppCenterCorePackageDetails AppCenterCorePackageDetails;
typedef struct _AppCenterCorePackageDetailsClass AppCenterCorePackageDetailsClass;

#define APP_CENTER_CORE_TYPE_CHANGE_INFORMATION (app_center_core_change_information_get_type ())
#define APP_CENTER_CORE_CHANGE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION, AppCenterCoreChangeInformation))
#define APP_CENTER_CORE_CHANGE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION, AppCenterCoreChangeInformationClass))
#define APP_CENTER_CORE_IS_CHANGE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION))
#define APP_CENTER_CORE_IS_CHANGE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION))
#define APP_CENTER_CORE_CHANGE_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APP_CENTER_CORE_TYPE_CHANGE_INFORMATION, AppCenterCoreChangeInformationClass))

typedef struct _AppCenterCoreChangeInformation AppCenterCoreChangeInformation;
typedef struct _AppCenterCoreChangeInformationClass AppCenterCoreChangeInformationClass;

struct _AppCenterCoreBackendIface {
	GTypeInterface parent_iface;
	void (*get_installed_applications) (AppCenterCoreBackend* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeCollection* (*get_installed_applications_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_);
	GeeCollection* (*get_applications_for_category) (AppCenterCoreBackend* self, AsCategory* category);
	GeeCollection* (*search_applications) (AppCenterCoreBackend* self, const gchar* query, AsCategory* category);
	GeeCollection* (*search_applications_mime) (AppCenterCoreBackend* self, const gchar* query);
	AppCenterCorePackage* (*get_package_for_component_id) (AppCenterCoreBackend* self, const gchar* id);
	GeeCollection* (*get_packages_for_component_id) (AppCenterCoreBackend* self, const gchar* id);
	AppCenterCorePackage* (*get_package_for_desktop_id) (AppCenterCoreBackend* self, const gchar* id);
	GeeCollection* (*get_packages_by_author) (AppCenterCoreBackend* self, const gchar* author, gint max);
	void (*refresh_cache) (AppCenterCoreBackend* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*refresh_cache_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*get_download_size) (AppCenterCoreBackend* self, AppCenterCorePackage* package, GCancellable* cancellable, gboolean is_update, GAsyncReadyCallback _callback_, gpointer _user_data_);
	guint64 (*get_download_size_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*is_package_installed) (AppCenterCoreBackend* self, AppCenterCorePackage* package, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*is_package_installed_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*get_package_details) (AppCenterCoreBackend* self, AppCenterCorePackage* package, GAsyncReadyCallback _callback_, gpointer _user_data_);
	AppCenterCorePackageDetails* (*get_package_details_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*install_package) (AppCenterCoreBackend* self, AppCenterCorePackage* package, AppCenterCoreChangeInformation* change_info, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*install_package_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*update_package) (AppCenterCoreBackend* self, AppCenterCorePackage* package, AppCenterCoreChangeInformation* change_info, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*update_package_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	void (*remove_package) (AppCenterCoreBackend* self, AppCenterCorePackage* package, AppCenterCoreChangeInformation* change_info, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*remove_package_finish) (AppCenterCoreBackend* self, GAsyncResult* _res_, GError** error);
	gboolean (*get_working) (AppCenterCoreBackend* self);
	void (*set_working) (AppCenterCoreBackend* self, gboolean value);
};

VALA_EXTERN GType backend_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType app_center_core_package_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCorePackage, g_object_unref)
VALA_EXTERN GType app_center_core_package_details_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCorePackageDetails, g_object_unref)
VALA_EXTERN GType app_center_core_change_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreChangeInformation, g_object_unref)
VALA_EXTERN GType app_center_core_backend_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppCenterCoreBackend, g_object_unref)
VALA_EXTERN void app_center_core_backend_get_installed_applications (AppCenterCoreBackend* self,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
VALA_EXTERN GeeCollection* app_center_core_backend_get_installed_applications_finish (AppCenterCoreBackend* self,
                                                                          GAsyncResult* _res_);
VALA_EXTERN GeeCollection* app_center_core_backend_get_applications_for_category (AppCenterCoreBackend* self,
                                                                      AsCategory* category);
VALA_EXTERN GeeCollection* app_center_core_backend_search_applications (AppCenterCoreBackend* self,
                                                            const gchar* query,
                                                            AsCategory* category);
VALA_EXTERN GeeCollection* app_center_core_backend_search_applications_mime (AppCenterCoreBackend* self,
                                                                 const gchar* query);
VALA_EXTERN AppCenterCorePackage* app_center_core_backend_get_package_for_component_id (AppCenterCoreBackend* self,
                                                                            const gchar* id);
VALA_EXTERN GeeCollection* app_center_core_backend_get_packages_for_component_id (AppCenterCoreBackend* self,
                                                                      const gchar* id);
VALA_EXTERN AppCenterCorePackage* app_center_core_backend_get_package_for_desktop_id (AppCenterCoreBackend* self,
                                                                          const gchar* id);
VALA_EXTERN GeeCollection* app_center_core_backend_get_packages_by_author (AppCenterCoreBackend* self,
                                                               const gchar* author,
                                                               gint max);
VALA_EXTERN void app_center_core_backend_refresh_cache (AppCenterCoreBackend* self,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_refresh_cache_finish (AppCenterCoreBackend* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
VALA_EXTERN void app_center_core_backend_get_download_size (AppCenterCoreBackend* self,
                                                AppCenterCorePackage* package,
                                                GCancellable* cancellable,
                                                gboolean is_update,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN guint64 app_center_core_backend_get_download_size_finish (AppCenterCoreBackend* self,
                                                          GAsyncResult* _res_,
                                                          GError** error);
VALA_EXTERN void app_center_core_backend_is_package_installed (AppCenterCoreBackend* self,
                                                   AppCenterCorePackage* package,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_is_package_installed_finish (AppCenterCoreBackend* self,
                                                              GAsyncResult* _res_,
                                                              GError** error);
VALA_EXTERN void app_center_core_backend_get_package_details (AppCenterCoreBackend* self,
                                                  AppCenterCorePackage* package,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
VALA_EXTERN AppCenterCorePackageDetails* app_center_core_backend_get_package_details_finish (AppCenterCoreBackend* self,
                                                                                 GAsyncResult* _res_,
                                                                                 GError** error);
VALA_EXTERN void app_center_core_backend_install_package (AppCenterCoreBackend* self,
                                              AppCenterCorePackage* package,
                                              AppCenterCoreChangeInformation* change_info,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_install_package_finish (AppCenterCoreBackend* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
VALA_EXTERN void app_center_core_backend_update_package (AppCenterCoreBackend* self,
                                             AppCenterCorePackage* package,
                                             AppCenterCoreChangeInformation* change_info,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_update_package_finish (AppCenterCoreBackend* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
VALA_EXTERN void app_center_core_backend_remove_package (AppCenterCoreBackend* self,
                                             AppCenterCorePackage* package,
                                             AppCenterCoreChangeInformation* change_info,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN gboolean app_center_core_backend_remove_package_finish (AppCenterCoreBackend* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
VALA_EXTERN gboolean app_center_core_backend_get_working (AppCenterCoreBackend* self);
VALA_EXTERN void app_center_core_backend_set_working (AppCenterCoreBackend* self,
                                          gboolean value);
static GType app_center_core_backend_get_type_once (void);

static GType
backend_type_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKEND_TYPE_PACKAGEKIT, "BACKEND_TYPE_PACKAGEKIT", "packagekit"}, {BACKEND_TYPE_UBUNTU_DRIVERS, "BACKEND_TYPE_UBUNTU_DRIVERS", "ubuntu-drivers"}, {0, NULL, NULL}};
	GType backend_type_type_id;
	backend_type_type_id = g_enum_register_static ("BackendType", values);
	return backend_type_type_id;
}

GType
backend_type_get_type (void)
{
	static volatile gsize backend_type_type_id__once = 0;
	if (g_once_init_enter (&backend_type_type_id__once)) {
		GType backend_type_type_id;
		backend_type_type_id = backend_type_get_type_once ();
		g_once_init_leave (&backend_type_type_id__once, backend_type_type_id);
	}
	return backend_type_type_id__once;
}

void
app_center_core_backend_get_installed_applications (AppCenterCoreBackend* self,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_installed_applications) {
		_iface_->get_installed_applications (self, cancellable, _callback_, _user_data_);
	}
}

GeeCollection*
app_center_core_backend_get_installed_applications_finish (AppCenterCoreBackend* self,
                                                           GAsyncResult* _res_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_installed_applications_finish) {
		return _iface_->get_installed_applications_finish (self, _res_);
	}
	return NULL;
}

GeeCollection*
app_center_core_backend_get_applications_for_category (AppCenterCoreBackend* self,
                                                       AsCategory* category)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_applications_for_category) {
		return _iface_->get_applications_for_category (self, category);
	}
	return NULL;
}

GeeCollection*
app_center_core_backend_search_applications (AppCenterCoreBackend* self,
                                             const gchar* query,
                                             AsCategory* category)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->search_applications) {
		return _iface_->search_applications (self, query, category);
	}
	return NULL;
}

GeeCollection*
app_center_core_backend_search_applications_mime (AppCenterCoreBackend* self,
                                                  const gchar* query)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->search_applications_mime) {
		return _iface_->search_applications_mime (self, query);
	}
	return NULL;
}

AppCenterCorePackage*
app_center_core_backend_get_package_for_component_id (AppCenterCoreBackend* self,
                                                      const gchar* id)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_package_for_component_id) {
		return _iface_->get_package_for_component_id (self, id);
	}
	return NULL;
}

GeeCollection*
app_center_core_backend_get_packages_for_component_id (AppCenterCoreBackend* self,
                                                       const gchar* id)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_packages_for_component_id) {
		return _iface_->get_packages_for_component_id (self, id);
	}
	return NULL;
}

AppCenterCorePackage*
app_center_core_backend_get_package_for_desktop_id (AppCenterCoreBackend* self,
                                                    const gchar* id)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_package_for_desktop_id) {
		return _iface_->get_package_for_desktop_id (self, id);
	}
	return NULL;
}

GeeCollection*
app_center_core_backend_get_packages_by_author (AppCenterCoreBackend* self,
                                                const gchar* author,
                                                gint max)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_packages_by_author) {
		return _iface_->get_packages_by_author (self, author, max);
	}
	return NULL;
}

void
app_center_core_backend_refresh_cache (AppCenterCoreBackend* self,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->refresh_cache) {
		_iface_->refresh_cache (self, cancellable, _callback_, _user_data_);
	}
}

gboolean
app_center_core_backend_refresh_cache_finish (AppCenterCoreBackend* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->refresh_cache_finish) {
		return _iface_->refresh_cache_finish (self, _res_, error);
	}
	return FALSE;
}

void
app_center_core_backend_get_download_size (AppCenterCoreBackend* self,
                                           AppCenterCorePackage* package,
                                           GCancellable* cancellable,
                                           gboolean is_update,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_download_size) {
		_iface_->get_download_size (self, package, cancellable, is_update, _callback_, _user_data_);
	}
}

guint64
app_center_core_backend_get_download_size_finish (AppCenterCoreBackend* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_download_size_finish) {
		return _iface_->get_download_size_finish (self, _res_, error);
	}
	return 0ULL;
}

void
app_center_core_backend_is_package_installed (AppCenterCoreBackend* self,
                                              AppCenterCorePackage* package,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->is_package_installed) {
		_iface_->is_package_installed (self, package, _callback_, _user_data_);
	}
}

gboolean
app_center_core_backend_is_package_installed_finish (AppCenterCoreBackend* self,
                                                     GAsyncResult* _res_,
                                                     GError** error)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->is_package_installed_finish) {
		return _iface_->is_package_installed_finish (self, _res_, error);
	}
	return FALSE;
}

void
app_center_core_backend_get_package_details (AppCenterCoreBackend* self,
                                             AppCenterCorePackage* package,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_package_details) {
		_iface_->get_package_details (self, package, _callback_, _user_data_);
	}
}

AppCenterCorePackageDetails*
app_center_core_backend_get_package_details_finish (AppCenterCoreBackend* self,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_package_details_finish) {
		return _iface_->get_package_details_finish (self, _res_, error);
	}
	return NULL;
}

void
app_center_core_backend_install_package (AppCenterCoreBackend* self,
                                         AppCenterCorePackage* package,
                                         AppCenterCoreChangeInformation* change_info,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->install_package) {
		_iface_->install_package (self, package, change_info, cancellable, _callback_, _user_data_);
	}
}

gboolean
app_center_core_backend_install_package_finish (AppCenterCoreBackend* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->install_package_finish) {
		return _iface_->install_package_finish (self, _res_, error);
	}
	return FALSE;
}

void
app_center_core_backend_update_package (AppCenterCoreBackend* self,
                                        AppCenterCorePackage* package,
                                        AppCenterCoreChangeInformation* change_info,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->update_package) {
		_iface_->update_package (self, package, change_info, cancellable, _callback_, _user_data_);
	}
}

gboolean
app_center_core_backend_update_package_finish (AppCenterCoreBackend* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->update_package_finish) {
		return _iface_->update_package_finish (self, _res_, error);
	}
	return FALSE;
}

void
app_center_core_backend_remove_package (AppCenterCoreBackend* self,
                                        AppCenterCorePackage* package,
                                        AppCenterCoreChangeInformation* change_info,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->remove_package) {
		_iface_->remove_package (self, package, change_info, cancellable, _callback_, _user_data_);
	}
}

gboolean
app_center_core_backend_remove_package_finish (AppCenterCoreBackend* self,
                                               GAsyncResult* _res_,
                                               GError** error)
{
	AppCenterCoreBackendIface* _iface_;
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->remove_package_finish) {
		return _iface_->remove_package_finish (self, _res_, error);
	}
	return FALSE;
}

gboolean
app_center_core_backend_get_working (AppCenterCoreBackend* self)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->get_working) {
		return _iface_->get_working (self);
	}
	return FALSE;
}

void
app_center_core_backend_set_working (AppCenterCoreBackend* self,
                                     gboolean value)
{
	AppCenterCoreBackendIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = APP_CENTER_CORE_BACKEND_GET_INTERFACE (self);
	if (_iface_->set_working) {
		_iface_->set_working (self, value);
	}
}

static void
app_center_core_backend_default_init (AppCenterCoreBackendIface * iface,
                                      gpointer iface_data)
{
	g_object_interface_install_property (iface, g_param_spec_boolean ("working", "working", "working", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static GType
app_center_core_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppCenterCoreBackendIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_center_core_backend_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType app_center_core_backend_type_id;
	app_center_core_backend_type_id = g_type_register_static (G_TYPE_INTERFACE, "AppCenterCoreBackend", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (app_center_core_backend_type_id, G_TYPE_OBJECT);
	return app_center_core_backend_type_id;
}

GType
app_center_core_backend_get_type (void)
{
	static volatile gsize app_center_core_backend_type_id__once = 0;
	if (g_once_init_enter (&app_center_core_backend_type_id__once)) {
		GType app_center_core_backend_type_id;
		app_center_core_backend_type_id = app_center_core_backend_get_type_once ();
		g_once_init_leave (&app_center_core_backend_type_id__once, app_center_core_backend_type_id);
	}
	return app_center_core_backend_type_id__once;
}

