/* Utils.c generated by valac 0.56.3, the Vala compiler
 * generated from Utils.vala, do not modify */

/* Copyright 2018 elementary, Inc. (https://elementary.io)
*
* This program is free software: you can redistribute it
* and/or modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
* Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program. If not, see http://www.gnu.org/licenses/.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <packagekit-glib2/packagekit.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

VALA_EXTERN void utils_shuffle_array (GType t_type,
                          GBoxedCopyFunc t_dup_func,
                          GDestroyNotify t_destroy_func,
                          gpointer* array,
                          gint array_length1);
VALA_EXTERN void utils_swap (GType t_type,
                 GBoxedCopyFunc t_dup_func,
                 GDestroyNotify t_destroy_func,
                 gconstpointer* x,
                 gconstpointer* y);
VALA_EXTERN guint utils_get_file_age (GFile* file);
VALA_EXTERN const gchar* utils_pk_status_to_string (PkStatusEnum status);
VALA_EXTERN gchar* utils_unescape_markup (const gchar* escaped_text);

void
utils_shuffle_array (GType t_type,
                     GBoxedCopyFunc t_dup_func,
                     GDestroyNotify t_destroy_func,
                     gpointer* array,
                     gint array_length1)
{
	GRand* rand = NULL;
	GRand* _tmp0_;
	_tmp0_ = g_rand_new ();
	rand = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GRand* _tmp3_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i < (array_length1 * 3))) {
					break;
				}
				_tmp3_ = rand;
				utils_swap (G_TYPE_POINTER, NULL, NULL, &array[0], &array[g_rand_int_range (_tmp3_, (gint32) 1, (gint32) array_length1)]);
			}
		}
	}
	_g_rand_free0 (rand);
}

void
utils_swap (GType t_type,
            GBoxedCopyFunc t_dup_func,
            GDestroyNotify t_destroy_func,
            gconstpointer* x,
            gconstpointer* y)
{
	gpointer tmp = NULL;
	gpointer _tmp0_;
	_tmp0_ = (((*x) != NULL) && (t_dup_func != NULL)) ? t_dup_func ((gpointer) (*x)) : ((gpointer) (*x));
	tmp = _tmp0_;
	*x = *y;
	*y = tmp;
	((tmp == NULL) || (t_destroy_func == NULL)) ? NULL : (tmp = (t_destroy_func (tmp), NULL));
}

guint
utils_get_file_age (GFile* file)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	guint64 mtime = 0ULL;
	GFileInfo* _tmp7_;
	guint64 now = 0ULL;
	time_t _tmp8_;
	GError* _inner_error0_ = NULL;
	guint result;
	g_return_val_if_fail (file != NULL, 0U);
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
		_tmp1_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (info);
		info = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("Utils.vala:37: Error while getting file age: %s", _tmp4_);
		result = G_MAXUINT;
		_g_error_free0 (e);
		_g_object_unref0 (info);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint _tmp5_ = 0U;
		_g_object_unref0 (info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	_tmp6_ = info;
	if (_tmp6_ == NULL) {
		result = G_MAXUINT;
		_g_object_unref0 (info);
		return result;
	}
	_tmp7_ = info;
	mtime = g_file_info_get_attribute_uint64 (_tmp7_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
	_tmp8_ = time (NULL);
	now = (guint64) _tmp8_;
	if (mtime > now) {
		result = G_MAXUINT;
		_g_object_unref0 (info);
		return result;
	}
	if ((now - mtime) > ((guint64) G_MAXUINT)) {
		result = G_MAXUINT;
		_g_object_unref0 (info);
		return result;
	}
	result = (guint) (now - mtime);
	_g_object_unref0 (info);
	return result;
}

const gchar*
utils_pk_status_to_string (PkStatusEnum status)
{
	const gchar* result;
	switch (status) {
		case PK_STATUS_ENUM_SETUP:
		{
			result = _ ("Starting");
			return result;
		}
		case PK_STATUS_ENUM_WAIT:
		{
			result = _ ("Waiting");
			return result;
		}
		case PK_STATUS_ENUM_RUNNING:
		{
			result = _ ("Running");
			return result;
		}
		case PK_STATUS_ENUM_QUERY:
		{
			result = _ ("Querying");
			return result;
		}
		case PK_STATUS_ENUM_INFO:
		{
			result = _ ("Getting information");
			return result;
		}
		case PK_STATUS_ENUM_REMOVE:
		{
			result = _ ("Removing packages");
			return result;
		}
		case PK_STATUS_ENUM_DOWNLOAD:
		{
			result = _ ("Downloading");
			return result;
		}
		case PK_STATUS_ENUM_INSTALL:
		{
			result = _ ("Installing");
			return result;
		}
		case PK_STATUS_ENUM_REFRESH_CACHE:
		{
			result = _ ("Refreshing software list");
			return result;
		}
		case PK_STATUS_ENUM_UPDATE:
		{
			result = _ ("Installing updates");
			return result;
		}
		case PK_STATUS_ENUM_CLEANUP:
		{
			result = _ ("Cleaning up packages");
			return result;
		}
		case PK_STATUS_ENUM_OBSOLETE:
		{
			result = _ ("Obsoleting packages");
			return result;
		}
		case PK_STATUS_ENUM_DEP_RESOLVE:
		{
			result = _ ("Resolving dependencies");
			return result;
		}
		case PK_STATUS_ENUM_SIG_CHECK:
		{
			result = _ ("Checking signatures");
			return result;
		}
		case PK_STATUS_ENUM_TEST_COMMIT:
		{
			result = _ ("Testing changes");
			return result;
		}
		case PK_STATUS_ENUM_COMMIT:
		{
			result = _ ("Committing changes");
			return result;
		}
		case PK_STATUS_ENUM_REQUEST:
		{
			result = _ ("Requesting data");
			return result;
		}
		case PK_STATUS_ENUM_FINISHED:
		{
			result = _ ("Finished");
			return result;
		}
		case PK_STATUS_ENUM_CANCEL:
		{
			result = _ ("Cancelling");
			return result;
		}
		case PK_STATUS_ENUM_DOWNLOAD_REPOSITORY:
		{
			result = _ ("Downloading repository information");
			return result;
		}
		case PK_STATUS_ENUM_DOWNLOAD_PACKAGELIST:
		{
			result = _ ("Downloading list of packages");
			return result;
		}
		case PK_STATUS_ENUM_DOWNLOAD_FILELIST:
		{
			result = _ ("Downloading file lists");
			return result;
		}
		case PK_STATUS_ENUM_DOWNLOAD_CHANGELOG:
		{
			result = _ ("Downloading lists of changes");
			return result;
		}
		case PK_STATUS_ENUM_DOWNLOAD_GROUP:
		{
			result = _ ("Downloading groups");
			return result;
		}
		case PK_STATUS_ENUM_DOWNLOAD_UPDATEINFO:
		{
			result = _ ("Downloading update information");
			return result;
		}
		case PK_STATUS_ENUM_REPACKAGING:
		{
			result = _ ("Repackaging files");
			return result;
		}
		case PK_STATUS_ENUM_LOADING_CACHE:
		{
			result = _ ("Loading cache");
			return result;
		}
		case PK_STATUS_ENUM_SCAN_APPLICATIONS:
		{
			result = _ ("Scanning applications");
			return result;
		}
		case PK_STATUS_ENUM_GENERATE_PACKAGE_LIST:
		{
			result = _ ("Generating package lists");
			return result;
		}
		case PK_STATUS_ENUM_WAITING_FOR_LOCK:
		{
			result = _ ("Waiting for package manager lock");
			return result;
		}
		case PK_STATUS_ENUM_WAITING_FOR_AUTH:
		{
			result = _ ("Waiting for authentication");
			return result;
		}
		case PK_STATUS_ENUM_SCAN_PROCESS_LIST:
		{
			result = _ ("Updating running applications");
			return result;
		}
		case PK_STATUS_ENUM_CHECK_EXECUTABLE_FILES:
		{
			result = _ ("Checking applications in use");
			return result;
		}
		case PK_STATUS_ENUM_CHECK_LIBRARIES:
		{
			result = _ ("Checking libraries in use");
			return result;
		}
		case PK_STATUS_ENUM_COPY_FILES:
		{
			result = _ ("Copying files");
			return result;
		}
		default:
		{
			result = _ ("Unknown state");
			return result;
		}
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
utils_unescape_markup (const gchar* escaped_text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
	g_return_val_if_fail (escaped_text != NULL, NULL);
	_tmp0_ = string_replace (escaped_text, "&amp;", "&");
	_tmp1_ = _tmp0_;
	_tmp2_ = string_replace (_tmp1_, "&lt;", "<");
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, "&gt;", ">");
	_tmp5_ = _tmp4_;
	_tmp6_ = string_replace (_tmp5_, "&#39;", "'");
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp7_;
	return result;
}

